/*
 *
 *  NNTP 饤֥
 *
 *  Copyright 1991-1996 Matsushita Soft Research, INC. A.Takuma
 *
 *  System      : NNTP protocol library
 *  Sub system  : NNTP library
 *  File        : nntplib.c
 *  Version     : 2.12
 *  First Edit  : 1991-07/25
 *  Last  Edit  : 1996-12/03
 *  Author      : MSR24  
 *
 */

#include	"compat.h"
#include	"nntplib.h"
#include	"field.h"

char			nntp_server[MAXHOSTNAMELEN];
					/* NNTP Хۥ̾(FQDN)	*/
char			nntp_server_file[PATH_BUFF] = NNTP_SERVER_FILE;
					/* NNTP лե	*/
char			post_program[PATH_BUFF] = POST_PROGRAM;
					/* ƥץ		*/
char			news_spool[PATH_BUFF] = NEWS_SPOOL;
					/* ˥塼ס		*/
char			news_lib[PATH_BUFF] = NEWS_LIB;
					/* ˥塼饤֥		*/
char			ignore_groups[BUFF_SIZE] = {0, 0};
					/* ̵뤹˥塼롼׷	*/
short			ignore_mode = 0;
					/* ̵뤹⡼		*/
short			nntp_connect_mode = 2;
					/* NNTP ³⡼		*/
					/* (0:NSPL,1:NNTP,2:DEAD)	*/
char			*nntp_connect_string[] = {
  "NSPL",
  "NNTP",
  "DEAD",
};
#ifdef	XOVER
short			xover_mode = 1;	/* XOVER ͭå		*/
#endif	/* XOVER */
short			post_enable = 1;/* Ƶĥե饰		*/
short			force_use_inews = 0;
int			group_number;	/* 롼׿			*/
					/*  local post ե饰	*/
#ifdef	NNTP
#ifdef	MSDOS
static int		read_fd = -1;
static int		write_fd = -1;
#else	/* !MSDOS */
static FILE		*read_fp = (FILE*)NULL;
static FILE		*write_fp = (FILE*)NULL;
#endif	/* !MSDOS */
static unsigned int	port_number = 0;
#endif	/* NNTP */
#ifdef	NSPL
static char		current_group[SMALL_BUFF];
#endif	/* NSPL */
static int		too_many;
#ifdef	NG_ALLOC
struct news_group	*news_group = (struct news_group*)NULL;
char			*name_pool = (char*)NULL;
long			name_used_size = 0;
static long		name_alloc_size = 0;
static int		news_alloc_number = 0;
#else	/* !NG_ALLOC */
struct news_group	news_group[MAX_NEWS_GROUP];
#endif	/* !NG_ALLOC */

static int	add_group();		/* ˥塼롼Ͽ		*/
#ifdef	NG_ALLOC
static int	compare_group();	/* ˥塼롼̾	*/
#endif	/* NG_ALLOC */
#ifdef	NSPL
static int	nspl_search_article();	/* 			*/
static void	post_pipe_error();	/* ѥץ顼ϥɥ		*/
#endif	/* NSPL */
#ifdef	NNTP
static int	nntp_auth();		/* NNTP ǧ		*/
static int	inn_check();		/* INN å			*/
#ifdef	XOVER
extern int	xover_copy_field();
#endif	/* XOVER */
#endif	/* NNTP */
static int	atoi2();

/*
 * NNTP 
 */

NNTP_ERR_CODE	nntp_select_server(server_name)
     char	*server_name;
{
#ifdef	NNTP
  struct hostent	*server_entry;
#endif	/* NNTP */
#ifdef	NSPL
  struct stat 		stat_buff;
#endif	/* NSPL */
  char			buff[PATH_BUFF];
  char			*ptr;
  NNTP_ERR_CODE		status;

  switch (nntp_connect_mode) {
  case 0:					/* NSPLNNTP ³	*/
#ifndef	NSPL
    nntp_connect_mode = 1;
#endif	/* NSPL */
    break;
  case 1:					/* NNTPNSPL ³	*/
#ifndef	NNTP
    nntp_connect_mode = 0;
#endif	/* NNTP */
    break;
  default:
    break;
  }
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    if (stat(news_lib, &stat_buff)) {
      print_fatal("Can't stat news library directory.");
      break;
    } else if (stat(news_spool, &stat_buff)) {
      print_fatal("Can't stat news spool directory.");
      break;
    }
    sprintf(buff, "%s%c%s", news_lib, SLASH_CHAR, NEWS_ACTIVE_FILE);
    if (stat(buff, &stat_buff)) {
      print_fatal("Can't stat news active file.");
      break;
    }
#ifdef	NNTP
    if (gethostname(nntp_server, sizeof(nntp_server))) {
      print_fatal("Can't get hostname.");
      break;
    }
#else	/* !NNTP */
    strcpy(nntp_server, "LOCAL");
#endif	/* !NNTP */
    status = NNTP_OK;
#else	/* !MSPL */
    print_fatal("NSPL mode unsupported.");
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    if (server_name != (char*)NULL) {
      strcpy(nntp_server, server_name);
      ptr = strchr(server_name, ':');
      if (ptr != (char*)NULL) {
	*ptr++ = '\0';
	if (atoi(ptr) > 0) {
	  port_number = atoi(ptr) & 0xFFFF;
	}
      }
    }
    if ((server_name == (char*)NULL) || (!server_name[0])) {
      if (get_default_server(nntp_server_file, nntp_server, "NNTPSERVER",
			     &port_number)) {
	if (gethostname(nntp_server, sizeof(nntp_server))) {
	  print_fatal("Can't get hostname.");
	  break;
	}
      }
    }
    if (!(server_entry = gethostbyname(nntp_server))) {
      print_warning("Can't get NNTP server host entry.");
    } else {
#ifndef	DONT_USE_REALNAME
      strcpy(nntp_server, server_entry->h_name);
#endif	/* !DONT_USE_REALNAME */
    }
    status = NNTP_OK;
#else	/* !NNTP */
    print_fatal("NNTP mode unsupported.");
    status = NNTP_ERR_RSV;
#endif	/* !NNTP */
    break;
  default:
    break;
  }
  if (status != NNTP_OK) {
    nntp_connect_mode = 2;
  }
  return(status);
}

/*
 * NNTP ץ
 */

NNTP_ERR_CODE	nntp_open()
{
  char		buff[SMALL_BUFF];
#ifdef	NSPL
  struct stat	stat_buff;
  char		*ptr;
#endif	/* NSPL */
#ifdef	NNTP
  int		sock_read, sock_write;
#endif	/* NNTP */
  NNTP_ERR_CODE	status;

  post_enable = 0;
  signal(SIGPIPE, SIG_IGN);
#ifdef	NNTP
#ifdef	MSDOS
  if ((write_fd != - 1) || (read_fd != - 1)) {
#else	/* !MSDOS */
  if ((write_fp != (FILE*)NULL) || (read_fp != (FILE*)NULL)) {
#endif	/* !MSDOS */
    print_fatal("NNTP server already open.");
    return(NNTP_ERR_PROG);
  }
#endif	/* NNTP */
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NNTP_DEBUG
    print_warning("Connecting to NSPL server %s.", nntp_server);
#endif	/* NNTP_DEBUG */
#ifdef	NSPL
    status = NNTP_OK;
#else	/* !NSPL */
    print_fatal("NSPL mode unsupported.");
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP_DEBUG
    print_warning("Connecting to NNTP server %s.", nntp_server);
#endif	/* NNTP_DEBUG */
#ifdef	NNTP
    if ((sock_read = get_tcp_socket(nntp_server, "NNTP", "nntp",
				    port_number, NNTP_PORT)) < 0) {
      print_fatal("Can't connect NNTP server %s.", nntp_server);
      break;
    }
#ifdef	MSDOS
    read_fd = sock_read;
    sock_write = sock_read;
    write_fd = sock_write;
#else	/* !MSDOS */
    if ((read_fp = fdopen(sock_read, "r")) == (FILE*)NULL) {
      print_fatal("Can't connect NNTP server %s.", nntp_server);
      break;
    }
    sock_write = dup(sock_read);
    if ((write_fp = fdopen(sock_write, "w")) == (FILE*)NULL) {
      print_fatal("Can't connect NNTP server %s.", nntp_server);
      fclose(read_fp);
      read_fp = (FILE*)NULL;
      break;
    }
#endif	/* !MSDOS */
    group_number = 0;
    
    /*
     * NNTP Ф³å
     */
    
    if (nntp_receive(buff, sizeof(buff))) {
      break;
    }
    switch (atoi(buff)) {
    case NNTP_OPEN_RES1:
      post_enable = 1;
      /* break  */
    case NNTP_OPEN_RES2:
      status = NNTP_OK;
      break;
    case NNTP_BUSY_RES:
      print_warning("NNTP server busy.");
#ifdef	MSDOS
      closesocket(write_fd);
      read_fd = write_fd = -1;
#else	/* !MSDOS */
      if (write_fp != (FILE*)NULL) {
	fclose(write_fp);
	write_fp = (FILE*)NULL;
      }
      if (read_fp != (FILE*)NULL) {
	fclose(read_fp);
	read_fp = (FILE*)NULL;
      }
#endif	/* !MSDOS */
      status = NNTP_ERR_BUSY;
      break;
    default:
      print_fatal("Unexpected NNTP reply in connect sequence.");
      break;
    }
    if (status == NNTP_OK) {
      
      /* Server check innd or not */
      
      if (inn_check(buff)) {
	status = NNTP_ERR_COMM;
	if (nntp_send(NNTP_READER_CMD)) {
	  break;
	}
	if (nntp_receive(buff, sizeof(buff))) {
	  break;
	}
	switch (atoi(buff)) {
	case NNTP_OPEN_RES1:
	  post_enable = 1;
	  /* break  */
	case NNTP_OPEN_RES2:
	  status = NNTP_OK;
	  break;
	case NNTP_BUSY_RES:
	  print_warning("NNTP server busy.");
	  status = NNTP_ERR_BUSY;
	  break;
	default:
	  print_fatal("Unexpected NNTP reply in connect sequence.");
	  status = NNTP_ERR_PROT;
	  break;
	}
      }
    }
    if (status == NNTP_OK) {
      status = nntp_auth();
    }
#else	/* !NNTP */
    print_fatal("NNTP mode unsupported.");
#endif	/* !NNTP */
    break;
  case 2:
    status = NNTP_ERR_RSV;
    /* break  */
  default:
    break;
  }
  if (status != NNTP_OK) {
    nntp_close();
    nntp_connect_mode = 2;
  } else {
    if ((!nntp_connect_mode) || force_use_inews) {
      post_enable = 0;
#ifdef	NSPL
      strcpy(buff, post_program);
      ptr = strchr(buff, ' ');
      if (ptr != (char*)NULL) {
	*ptr = '\0';
      }
      if (!stat(buff, &stat_buff)) {
	post_enable = 1;
      }
#endif	/* NSPL */
    }
  }
  return(status);
}

/*
 * NNTP 
 */

NNTP_ERR_CODE	nntp_close()
{
#ifdef	NNTP
  char		buff[BUFF_SIZE];
#endif	/* NNTP */
  NNTP_ERR_CODE	status;

  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    status = NNTP_OK;
#endif	/* NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
#ifdef	MSDOS
    if ((write_fd == -1) || (read_fd == -1)) {
      break;
    }
#else	/* !MSDOS */
    if ((write_fp == (FILE*)NULL) || (read_fp == (FILE*)NULL)) {
      break;
    }
#endif	/* !MSDOS */
    if (nntp_send(NNTP_QUIT_CMD)) {
      break;
    } else if (nntp_receive(buff, sizeof(buff))) {
      break;
    } else {
      if (atoi(buff) != NNTP_QUIT_RES) {
	print_warning("Unexpected NNTP reply in quit command.");
	break;
      }
    }
#ifdef	MSDOS
    closesocket(write_fd);
    read_fd = write_fd = -1;
#else	/* !MSDOS */
    if (write_fp != (FILE*)NULL) {
      fclose(write_fp);
      write_fp = (FILE*)NULL;
    }
    if (read_fp != (FILE*)NULL) {
      fclose(read_fp);
      read_fp = (FILE*)NULL;
    }
#endif	/* !MSDOS */
    status = NNTP_OK;
#endif	/* NNTP */
    break;
  default:
    break;
  }
  return(status);
}

/*
 * NNTP 
 */

NNTP_ERR_CODE	nntp_send(string)
     char	*string;
{
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
    print_fatal("NSPL write does not need.");
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
#ifdef	MSDOS
    if (tcp_send("NNTP", &read_fd, &write_fd, string)) {
      return(NNTP_ERR_COMM);
    } else {
      return(NNTP_OK);
    }
#else	/* !MSDOS */
    if (tcp_send("NNTP", &read_fp, &write_fp, string)) {
      return(NNTP_ERR_COMM);
    } else {
      return(NNTP_OK);
    }
#endif	/* !MSDOS */
#endif	/* NNTP */
    break;
  default:
    break;
  }
  return(NNTP_ERR_PROG);
}

/*
 * NNTP 
 */

NNTP_ERR_CODE	nntp_receive(ptr, size)
     char	*ptr;
     int	size;
{
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
    print_fatal("NSPL read does not need.");
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
#ifdef	MSDOS
    if (tcp_receive("NNTP", &read_fd, &write_fd, ptr, size)) {
      return(NNTP_ERR_COMM);
    } else {
      return(NNTP_OK);
    }
#else	/* !MSDOS */
    if (tcp_receive("NNTP", &read_fp, &write_fp, ptr, size)) {
      return(NNTP_ERR_COMM);
    } else {
      return(NNTP_OK);
    }
#endif	/* !MSDOS */
#endif	/* NNTP */
    break;
  default:
    break;
  }
  return(NNTP_ERR_PROG);
}

/*
 * NNTP ǧ
 *
 * (0:,:桼ǧڼ,:顼)
 */

static int	nntp_auth()
{
#ifdef	NNTP_AUTH
  static char	user[SMALL_BUFF];
  static char	pass[SMALL_BUFF];
  static int	first = 1;
  char		buff[BUFF_SIZE];

  if (first) {
    get_user_pass(nntp_server, user, pass);
  }
  if (!*user) {
    return(NNTP_OK);
  }
  sprintf(buff, "%s %s", NNTP_USER_CMD, user);
  if (nntp_send(buff)) {
    return(NNTP_ERR_COMM);
  }
  if (nntp_receive(buff, sizeof(buff))) {
    return(NNTP_ERR_COMM);
  }
  switch (atoi(buff)) {
  case NNTP_AUTHCOMP_RES:
  case NNTP_AUTHDONE_RES:
    first = 0;
    return(NNTP_OK);
    break;
  case NNTP_PASS_RES:
    break;
  default:
    return(NNTP_ERR_PROT);
  }
  sprintf(buff, "%s %s", NNTP_PASS_CMD, pass);
  if (nntp_send(buff)) {
    return(NNTP_ERR_COMM);
  }
  if (nntp_receive(buff, sizeof(buff))) {
    return(NNTP_ERR_COMM);
  }
  switch (atoi(buff)) {
  case NNTP_AUTHCOMP_RES:
  case NNTP_AUTHDONE_RES:
    break;
  default:
    return(NNTP_ERR_PROT);
  }
  first = 0;
  return(NNTP_OK);			/* Authentication accepted */
#else	/* !NNTP_AUTH */
  return(NNTP_OK);
#endif	/* !NNTP_AUTH */
}

/*
 * ˥塼롼ץꥹȼ
 */

NNTP_ERR_CODE	nntp_list()
{
  char		buff[BUFF_SIZE];
  char		*ptr;
  int		first_line;
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  FILE		*fp;
#endif	/* NSPL */
  int		i;

#ifdef	NG_ALLOC
  nntp_free();
#endif	/* NG_ALLOC */
  first_line = 1;
  too_many = 0;
  group_number = 0;
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    sprintf(buff, "%s%c%s", news_lib, SLASH_CHAR, NEWS_ACTIVE_FILE);
    if ((fp = fopen(buff, "r")) == (FILE*)NULL) {
      print_fatal("Can't open news active list.");
      break;
    }
    status = NNTP_OK;
    while (fgets(buff, sizeof(buff), fp)) {
      ptr = buff;		/* 롼׾	*/
      if ((status = add_group(ptr)) != NNTP_OK) {
	break;
      }
    }
    fclose(fp);
#endif	/* NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    if (nntp_send(NNTP_LIST_CMD)) {
      break;
    }
    status = NNTP_OK;
    while (1) {
      if (nntp_receive(buff, sizeof(buff))) {
	status = NNTP_ERR_COMM;
	break;
      }
      ptr = buff;
      if (first_line) {		/* ơ	*/
	if (atoi(ptr) != NNTP_LIST_RES) {
	  print_fatal("Unexpected NNTP reply in list command.");
	  status = NNTP_ERR_PROT;
	  break;
	}
	first_line = 0;
      } else {			/* 롼׾	*/
	if ((buff[0] == NNTP_END_MARK) && (!buff[1])) {
	  break;
	}
	if (add_group(ptr)) {
	  status = NNTP_ERR_PROG;
	}
      }
    }
#endif	/* NNTP */
    break;
  default:
    break;
  }
  if (status != NNTP_OK) {
    group_number = 0;
#ifdef	NG_ALLOC
    nntp_free();
#endif	/* NG_ALLOC */
  } else {
#ifdef	NG_SORT
    for (i = 0; i < group_number; i++) {	/* 	*/
      ptr = news_group[i].group_name;
      while (*ptr) {
	if (*ptr == NEWS_GROUP_SEPARATER) {
	  *ptr++ = ' ';
	} else {
	  ptr++;
	}
      }
    }
#ifdef	NG_ALLOC
    qsort(news_group, group_number, sizeof(struct news_group), compare_group);
#else	/* !NG_ALLOC */
    qsort(news_group, group_number, sizeof(struct news_group),
	  (int (*)())strcmp);
#endif	/* !NG_ALLOC */
    for (i = 0; i < group_number; i++) {	/* θ	*/
      ptr = news_group[i].group_name;
      while (*ptr) {
	if (*ptr == ' ') {
	  *ptr++ = NEWS_GROUP_SEPARATER;
	} else {
	  ptr++;
	}
      }

      /*
       * ˥塼롼פʣƤΥ顼
       */

      if (i > 0) {
	if (!strcmp(news_group[i - 1].group_name, news_group[i].group_name)) {
	  print_warning("Duplicate news group %s.", news_group[i].group_name);
	  if ((group_number - i) > 0) {
	    bcopy(&news_group[i], &news_group[i - 1],
		  sizeof(struct news_group) * (group_number - i));
	  }
	  group_number--;
	  i--;
	}
      }
    }
#else	/* !NG_SORT */

    /*
     * ˥塼롼פʣƤΥ顼
     */

    for (i = 0; i < group_number - 1; i++) {
      if (!strcmp(news_group[i].group_name, news_group[i + 1].group_name)) {
	print_warning("Duplicate news group %s.", news_group[i].group_name);
	group_number--;
	if ((group_number - i) > 0) {
	  bcopy(&news_group[i + 1], &news_group[i],
		sizeof(struct news_group) * (group_number - i));
	}
	i--;
      }
    }
#endif	/* NG_SORT */
  }
  return(status);
}

/*
 * ˥塼롼ץꥹȼ
 */

#ifdef	NG_ALLOC
NNTP_ERR_CODE	nntp_free()
{
  if (news_group) {
    large_free(news_group);
  }
  if (name_pool) {
    large_free(name_pool);
  }
  news_group = (struct news_group*)NULL;
  name_pool = (char*)NULL;
  news_alloc_number = 0;
  name_alloc_size = name_used_size = 0;
  return(NNTP_OK);
}
#endif	/* NG_ALLOC */

/*
 * ˥塼롼Ͽ
 */

static int	add_group(ptr)
     char	*ptr;
{
  struct news_group	*alloc_ptr;
  register unsigned int	length;
  register int		i;
  char			name_buff[MAX_GROUP_NAME];
  char			*ptr2;

  /*	˥塼롼̾	*/

  length = 0;
  ptr2 = name_buff;
  while (*ptr > ' ') {
    if (length < (sizeof(name_buff) - 1)) {
      *ptr2++ = *ptr++;
      length++;
    } else {
      *ptr2 = '\0';
      print_fatal("Too long news group name %s.", name_buff);
      return(NNTP_OK);
    }
  }
  *ptr2 = '\0';
  length++;

  ptr2 = ignore_groups;
  if (ignore_mode) {
    i = 0;
    while (*ptr2) {
      i = strlen(ptr2);
      if (!strncmp(name_buff, ptr2, i)) {
	i = 0;
	break;
      }
      ptr2 += (i + 1);
    }
    if (i) {
      return(NNTP_OK);
    }
  } else {
    while (*ptr2) {
      i = strlen(ptr2);
      if (!strncmp(name_buff, ptr2, i)) {
	return(NNTP_OK);
      }
      ptr2 += (i + 1);
    }
  }

#ifdef	NG_ALLOC
  /*
   * ʬ NNTP Library ǰֱʬǤ
   * ˲ɤʤȤΤǤ礦
   */

  if (group_number >= news_alloc_number) {
    if (news_group) {
      if (alloc_ptr = (struct news_group*)
	  large_realloc(news_group, (long)sizeof(struct news_group) *
			(long)(news_alloc_number + NG_ALLOC_COUNT))) {
	news_group = alloc_ptr;
      } else {
	print_fatal("Can't allocate memory for news struct.");
	return(NNTP_ERR_MEM);
      }
    } else {
      if (!(news_group = (struct news_group*)
	    large_malloc((long)sizeof(struct news_group) *
			 (long)(news_alloc_number + NG_ALLOC_COUNT)))) {
	print_fatal("Can't allocate memory for news struct.");
	return(NNTP_ERR_MEM);
      }
    }
    news_alloc_number += NG_ALLOC_COUNT;
  }
  alloc_ptr = &news_group[group_number];
  if (length >= (name_alloc_size - name_used_size)) {
    if (name_pool) {
      if (ptr2 = (char*)large_realloc(name_pool,
				      (long)name_alloc_size +
				      (long)NAME_ALLOC_SIZE)) {
	if (name_pool != ptr2) {
	  for (i = 0; i < group_number; i++) {
#if	defined(MSDOS) && !defined(X68K) && !defined(__GO32__)
	    news_group[i].group_name = ptr2 +
	      ((unsigned)news_group[i].group_name - (unsigned)name_pool);
#else	/* !MSDOS || X68K || __GO32__ */
	    news_group[i].group_name += (ptr2 - name_pool);
#endif	/* !MSDOS || X68K || __GO32__ */
	  }
	}
	name_pool = ptr2;
      } else {
	print_fatal("Can't allocate memory for name pool.");
	return(NNTP_ERR_MEM);
      }
    } else {
      if (!(name_pool = (char*)large_malloc((long)name_alloc_size +
					    (long)NAME_ALLOC_SIZE))) {
	print_fatal("Can't allocate memory for name pool.");
	return(NNTP_ERR_MEM);
      }
    }
    name_alloc_size += NAME_ALLOC_SIZE;
  }
  alloc_ptr->group_name = &name_pool[name_used_size];
  strcpy(alloc_ptr->group_name, name_buff);
  name_used_size += length;
#else	/* !NG_ALLOC */
  if (group_number >= MAX_NEWS_GROUP) {
    if (!too_many) {
      too_many = 1;
      print_fatal("Too many news group.");
    }
    return(NNTP_ERR_MEM);
  }
  alloc_ptr = &news_group[group_number];
  strcpy(alloc_ptr->group_name, name_buff);
#endif	/* !NG_ALLOC */
  
  /*	ݴɵֹ	*/
  
  if ((alloc_ptr->max_article = atoi2(&ptr)) <= 0) {
    alloc_ptr->max_article = 0;
    alloc_ptr->min_article = 0;
    atoi2(&ptr);		/* ǾݴɵֹΤƤ */
  } else {
    
    /*	Ǿݴɵֹ	*/
    
    if ((alloc_ptr->min_article = atoi2(&ptr)) < 0) {
      alloc_ptr->max_article = 0;
      alloc_ptr->min_article = 0;
    } else if (alloc_ptr->min_article == 0) {
      alloc_ptr->min_article = 1;
    }
  }
  
  /*	⡼ (y/n/m)		*/
  
  while ((*ptr == ' ') || (*ptr == '\t') || (*ptr == '\n')) {
    ptr++;
  }
  switch (*ptr) {
  case 'y':	/* ݥȲǽ	*/
  case 'Y':
    alloc_ptr->group_mode = (short)POST_ENABLE;
    break;
  case 'n':	/* ݥԲ	*/
  case 'N':
  case 'x':	/* ݥԲ	*/
  case 'X':
  case 'j':	/* Junk		*/
  case 'J':
  case '=':	/* ꥢ	*/
    alloc_ptr->group_mode = (short)POST_DISABLE;
    break;
  case 'm':	/* ǥ졼	*/
  case 'M':
    alloc_ptr->group_mode = (short)POST_MODERATED;
    break;
  default:
    print_warning("Unexpected news group mode %s.", alloc_ptr->group_name);
    alloc_ptr->group_mode = (short)POST_UNKNOWN;
    break;
  }
  group_number++;
  return(NNTP_OK);
}

#ifdef	NG_ALLOC

/*
 * ˥塼롼̾
 */

static int	compare_group(ptr1, ptr2)
     struct news_group	*ptr1;
     struct news_group	*ptr2;
{
  return(strcmp(ptr1->group_name, ptr2->group_name));
}
#endif	/* NG_ALLOC */

/*
 * ˥塼롼
 */

NNTP_ERR_CODE	nntp_group(group_name)
     char	*group_name;
{
  char		buff1[BUFF_SIZE];
#ifdef	NNTP
  char		buff2[BUFF_SIZE];
  int		status;
  int		estimate_number;
  int		first_number;
  int		last_number;
#endif	/* NNTP */
#ifdef	NSPL
  struct stat 	stat_buff;
  char		*ptr;
#endif	/* NSPL */

  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    strcpy(buff1, group_name);
    ptr = buff1;
    while (*ptr) {
      if (*ptr == NEWS_GROUP_SEPARATER) {
	*ptr = SLASH_CHAR;
      }
      ptr++;
    }
    if (buff1[0] == NEWS_GROUP_SEPARATER) {
      sprintf(current_group, "%s%s", news_spool, buff1);
    } else {
      sprintf(current_group, "%s%c%s", news_spool, SLASH_CHAR, buff1);
    }
#ifdef	XOVER
    xover_mode = 0;
#endif	/* XOVER */
    if (stat(current_group, &stat_buff)) {
      print_fatal("Invalid news group \"%s\".", group_name);
      current_group[0] = '\0';
      return(NNTP_ERR_NONE);
    }
#else	/* !NSPL */
    return(NNTP_ERR_RSV);
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    sprintf(buff1, "%s %s", NNTP_GROUP_CMD, group_name);
    if (nntp_send(buff1)) {
      return(NNTP_ERR_COMM);
    }
    if (nntp_receive(buff1, sizeof(buff1))) {	/* ơ	*/
      return(NNTP_ERR_COMM);
    }
    if (sscanf(buff1, "%d %d %d %d %s", &status, &estimate_number,
	       &first_number, &last_number, buff2) != 5) {
      print_fatal("Invalid news group \"%s\".", group_name);
      return(NNTP_ERR_PROT);
    }
    if (status != NNTP_GROUP_RES) {
      print_fatal("Unexpected NNTP reply in group command.");
      return(NNTP_ERR_PROT);
    }
#ifdef	XOVER
    if (xover_mode) {
      xover_mode = 0;
      if (!nntp_send(NNTP_XOVER_CMD)) {
	if (!nntp_receive(buff1, sizeof(buff1))) {
	  if (atoi(buff1) == NNTP_XOVER_RES) {
	    xover_mode = 1;
	    while (!nntp_receive(buff1, sizeof(buff1))) {
	      if ((buff1[0] == NNTP_END_MARK) && (!buff1[1])) {
		break;
	      }
	    }
	  }
	}
      }
    }
#endif	/* XOVER */
#else	/* !NNTP */
    return(NNTP_ERR_RSV);
#endif	/* !NNTP */
    break;
  default:
    return(NNTP_ERR_PROG);
    break;
  }
  return(NNTP_OK);
}

/*
 * ˥塼(ֹ)
 */

NNTP_ERR_CODE	nntp_article(article_number, fp1)
     int	article_number;
     FILE	*fp1;
{
  char	buff[NUMBER_BUFF];

  sprintf(buff, "%d", article_number);
  return(nntp_article2(buff, fp1));
}

/*
 * ˥塼(Message-ID )
 */

NNTP_ERR_CODE	nntp_article2(message_id, fp1)
     CASTPTR	message_id;
     FILE	*fp1;
{
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  int		first_line;
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  int		article_number;
  FILE		*fp2;
#endif	/* NSPL */

  first_line = 1;
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    if (!current_group[0]) {
      print_fatal("News group not selected.");
      status = NNTP_ERR_PROG;
      break;
    }
    if (atoi((char*)message_id) > 0) {
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR,
	      (char*)message_id);
    } else {
      if ((article_number = nspl_search_article(message_id)) <= 0) {
	break;
      }
      sprintf(buff1, "%s%c%d", current_group, SLASH_CHAR,
	      (int)article_number);
    }
    if ((fp2 = fopen(buff1, "r")) == (FILE*)NULL) {
      status = NNTP_ERR_NONE;
      break;
    }
    while (fgets(buff2, sizeof(buff2), fp2)) {
      fputs(buff2, fp1);
    }
    fclose(fp2);
    status = NNTP_OK;
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    sprintf(buff1, "%s %s", NNTP_ARTICLE_CMD, (char*)message_id);
    if (nntp_send(buff1)) {
      break;
    }
    status = NNTP_OK;
    while (1) {
      if (nntp_receive(buff2, sizeof(buff2))) {
	return(NNTP_ERR_COMM);
      }
      if (first_line) {		/* ơ	*/
	if (atoi(buff2) != NNTP_ARTICLE_RES) {
	  
	  /*
	   * 󥻥뤵ƤʤΤå
	   */
	  
	  if (atoi(buff2) != NNTP_NO_NUM_RES) {
	    print_fatal("Unexpected NNTP reply in article command.");
	    status = NNTP_ERR_PROT;
	    break;
	  } else {
	    status = NNTP_ERR_NONE;
	    break;
	  }
	}
	first_line = 0;
      } else {
	if (buff2[0] == NNTP_END_MARK) {
	  if (buff2[1]) {
	    fprintf(fp1, "%s\n", &buff2[1]);
	  } else {
	    break;
	  }
	} else {
	  fprintf(fp1, "%s\n", buff2);
	}
      }
    }
#else	/* !NNTP */
    status = NNTP_ERR_RSV;
#endif	/* !NNTP */
    break;
  default:
    break;
  }
  return(status);
}

/*
 * ˥塼إå(ֹ)
 */

NNTP_ERR_CODE	nntp_head(article_number, fp1)
     int	article_number;
     FILE	*fp1;
{
  char	buff[NUMBER_BUFF];

  sprintf(buff, "%d", article_number);
  return(nntp_head2(buff, fp1));
}

/*
 * ˥塼إå(Message-ID )
 */

NNTP_ERR_CODE	nntp_head2(message_id, fp1)
     char	*message_id;
     FILE	*fp1;
{
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  int		first_line;
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  int		article_number;
  FILE		*fp2;
#endif	/* NSPL */

  status = NNTP_ERR_COMM;
  first_line = 1;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    if (!current_group[0]) {
      print_fatal("News group not selected.");
      break;
    }
    if (atoi(message_id) > 0) {
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR, message_id);
    } else {
      if ((article_number = nspl_search_article(message_id)) <= 0) {
	break;
      }
      sprintf(buff1, "%s%c%d", current_group, SLASH_CHAR, article_number);
    }
    if ((fp2 = fopen(buff1, "r")) == (FILE*)NULL) {
      break;
    }
    status = NNTP_OK;
    while (fgets(buff2, sizeof(buff2), fp2)) {
      if ((!buff2[0]) || (buff2[0] == '\n')) {
	break;
      }
      fputs(buff2, fp1);
    }
    fclose(fp2);
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    sprintf(buff1, "%s %s", NNTP_HEAD_CMD, message_id);
    if (nntp_send(buff1)) {
      break;
    }
    status = NNTP_OK;
    while (1) {
      if (nntp_receive(buff2, sizeof(buff2))) {
	status = NNTP_ERR_COMM;
	break;
      }
      if (first_line) {		/* ơ	*/
	if (atoi(buff2) != NNTP_HEAD_RES) {
	  
	  /*
	   * 󥻥뤵ƤʤΤå
	   */
	  
	  if (atoi(buff2) != NNTP_NO_NUM_RES) {
	    print_fatal("Unexpected NNTP reply in head command.");
	    status = NNTP_ERR_COMM;
	    break;
	  } else {
	    status = NNTP_ERR_NONE;
	    break;
	  }
	}
	first_line = 0;
      } else {
	if (buff2[0] == NNTP_END_MARK) {
	  if (buff2[1]) {
	    fprintf(fp1, "%s\n", &buff2[1]);
	  } else {
	    break;
	  }
	} else {
	  fprintf(fp1, "%s\n", buff2);
	}
      }
    }
#else	/* !NNTP */
    status = NNTP_ERR_RSV;
#endif	/* !NNTP */
    break;
  default:
    break;
  }
  return(status);
}

/*
 * ˥塼եɼ(ֹ)
 */

NNTP_ERR_CODE	nntp_copy_fields(article_number, hdr_ptr, number, mask)
     int		article_number;
     struct cpy_hdr	*hdr_ptr;
     int		number;
     int		mask;
{
  char	buff[NUMBER_BUFF];

  sprintf(buff, "%d", article_number);
  return(nntp_copy_fields2(buff, hdr_ptr, number, mask));
}

/*
 * ˥塼եɼ(Message-ID )
 */

NNTP_ERR_CODE	nntp_copy_fields2(message_id, hdr_ptr, number, mask)
     char		*message_id;
     struct cpy_hdr	*hdr_ptr;
     int		number;
     int		mask;
{
  char		buff[BUFF_SIZE];
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  int		article_number;
  FILE		*fp;
#endif	/* NSPL */

  if (mask & CF_CLR_MASK) {
    copy_fields((FILE*)NULL, hdr_ptr, number, CF_CLR_MASK);
    mask &= !CF_CLR_MASK;
  }
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    if (!current_group[0]) {
      print_fatal("News group not selected.");
      status = NNTP_ERR_PROG;
      break;
    }
    if (atoi(message_id) > 0) {
      sprintf(buff, "%s%c%s", current_group, SLASH_CHAR, message_id);
    } else {
      if ((article_number = nspl_search_article(message_id)) <= 0) {
	break;
      }
      sprintf(buff, "%s%c%d", current_group, SLASH_CHAR, article_number);
    }
    if ((fp = fopen(buff, "r")) != (FILE*)NULL) {
      copy_fields(fp, hdr_ptr, number, CF_GET_MASK | CF_SPC_MASK);
      fclose(fp);
      status = NNTP_OK;
    } else {
      status = NNTP_ERR_NONE;
    }
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    sprintf(buff, "%s %s", NNTP_HEAD_CMD, message_id);
    if (nntp_send(buff)) {
      break;
    }
    if (nntp_receive(buff, sizeof(buff))) {
      break;
    }
    switch (atoi(buff)) {
    case NNTP_HEAD_RES:
      copy_fields((FILE*)NULL, hdr_ptr, number,
		  CF_GET_MASK | CF_SPC_MASK | CF_HED_MASK);
      status = NNTP_OK;
      break;
    case NNTP_NO_NUM_RES:	/* 󥻥	*/
      status = NNTP_ERR_NONE;
      break;
    default:
      print_fatal("Unexpected NNTP reply in head command.");
      break;
    }
#else	/* !NNTP */
    status = NNTP_ERR_RSV;
#endif	/* !NNTP */
    break;
  default:
    break;
  }
  return(status);
}

#ifndef	SMALL
/*
 * ˥塼ʸ(ֹ)
 */

NNTP_ERR_CODE	nntp_body(article_number, fp)
     int	article_number;
     FILE	*fp;
{
  char	buff[NUMBER_BUFF];

  sprintf(buff, "%d", article_number);
  return(nntp_body2(buff, fp));
}

/*
 * ˥塼ʸ(Message-ID )
 */

NNTP_ERR_CODE	nntp_body2(message_id, fp1)
     char	*message_id;
     FILE	*fp1;
{
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  int		first_line;
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  int		article_number;
  FILE		*fp2;
#endif	/* NSPL */

  first_line = 1;
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    if (!current_group[0]) {
      print_fatal("News group not selected.");
      status = NNTP_ERR_PROG;
      break;
    }
    if (atoi(message_id) > 0) {
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR, message_id);
    } else {
      if ((article_number = nspl_search_article(message_id)) <= 0) {
	break;
      }
      sprintf(buff1, "%s%c%d", current_group, SLASH_CHAR, article_number);
    }
    if ((fp2 = fopen(buff1, "r")) == (FILE*)NULL) {
      break;
    }
    status = NNTP_OK;
    while (fgets(buff2, sizeof(buff2), fp2)) {
      if (first_line) {
	if ((!buff2[0]) || (buff2[0] == '\n')) {
	  first_line = 0;
	}
      } else {
	fputs(buff2, fp1);
      }
    }
    fclose(fp2);
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    sprintf(buff1, "%s %s", NNTP_BODY_CMD, message_id);
    if (nntp_send(buff1)) {
      break;
    }
    status = NNTP_OK;
    while (1) {
      if (nntp_receive(buff2, sizeof(buff2))) {
	status = NNTP_ERR_COMM;
	break;
      }
      if (first_line) {		/* ơ	*/
	if (atoi(buff2) != NNTP_BODY_RES) {
	  
	  /*	󥻥뤵ƤʤΤå	*/
	  
	  if (atoi(buff2) != NNTP_NO_NUM_RES) {
	    print_fatal("Unexpected NNTP reply in body command.");
	    status = NNTP_ERR_PROT;
	    break;
	  } else {
	    status = NNTP_ERR_NONE;
	    break;
	  }
	}
	first_line = 0;
      } else {
	if (buff2[0] == NNTP_END_MARK) {
	  if (buff2[1]) {
	    fprintf(fp1, "%s\n", &buff2[1]);
	  } else {
	    break;
	  }
	} else {
	  fprintf(fp1, "%s\n", buff2);
	}
      }
    }
#else	/* !NNTP */
    status = NNTP_ERR_RSV;
#endif	/* !NNTP */
    break;
  default:
    break;
  }
  return(status);
}
#endif	/* !SMALL */

/*
 * ˥塼
 */

NNTP_ERR_CODE	nntp_post(file_name, domain_name)
     char	*file_name;
     char	*domain_name;
{
  FILE		*fp1;
#ifdef	NSPL
  FILE		*fp2;
#endif	/* NSPL */
  char		buff1[BUFF_SIZE];
#ifdef	NNTP
  char		buff2[BUFF_SIZE];
  char		*ptr;
#endif	/* NNTP */
  NNTP_ERR_CODE	status;

  if (!post_enable) {
    return(NNTP_ERR_RSV);
  }
  if ((fp1 = fopen(file_name, "r")) == (FILE*)NULL) {
    return(NNTP_ERR_PROG);
  }
  status = NNTP_ERR_COMM;
  if ((!nntp_connect_mode) || force_use_inews) {	/* NSPL ³	*/
#ifdef	NSPL
    signal(SIGPIPE, post_pipe_error);
#ifdef MSDOS
    strcpy(buff1, post_program);
#else	/* !MSDOS */
    sprintf(buff1, "%s > /dev/null 2>&1", post_program);
#endif	/* !MSDOS */
    if ((fp2 = popen(buff1, "w")) != (FILE*)NULL) {
      status = NNTP_OK;
      while (fgets(buff1, sizeof(buff1), fp1)) {
	if (fputs(buff1, fp2) == EOF) {
	  status = NNTP_ERR_COMM;
	  break;
	}
      }
      if (pclose(fp2)) {
	status = NNTP_ERR_COMM;
      }
    } else {
      print_fatal("Can't execute post command.");
    }
    signal(SIGPIPE, SIG_IGN);
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
  } else if (nntp_connect_mode == 1) {			/* NNTP ³	*/
#ifdef	NNTP
    if (!nntp_send(NNTP_POST_CMD)) {
      if (!nntp_receive(buff1, sizeof(buff1))) {
	if (atoi(buff1) == NNTP_POST_RES1) {
	  while (fgets(buff1, sizeof(buff1), fp1)) {
	    if ((!buff1[0]) || (buff1[0] == '\n')) {
	      break;
	    }
	    ptr = buff1;
	    while (*ptr) {
	      if (*ptr == '\n') {
		*ptr = '\0';
		break;
	      }
	      ptr++;
	    }
	    if (buff1[0] == NNTP_END_MARK) {
	      sprintf(buff2, "%c%s", NNTP_END_MARK, buff1);
	      nntp_send(buff2);
	    } else {
	      nntp_send(buff1);
	    }
	  }
	  nntp_send("");
	  while (fgets(buff1, sizeof(buff1), fp1)) {
	    ptr = buff1;
	    while (*ptr) {
	      if (*ptr == '\n') {
		*ptr = '\0';
		break;
	      }
	      ptr++;
	    }
	    if (buff1[0] == NNTP_END_MARK) {
	      sprintf(buff2, "%c%s", NNTP_END_MARK, buff1);
	      nntp_send(buff2);
	    } else {
	      nntp_send(buff1);
	    }
	  }
	  buff1[0] = NNTP_END_MARK;
	  buff1[1] = '\0';
	  nntp_send(buff1);
	  if (!nntp_receive(buff1, sizeof(buff1))) {
	    if (atoi(buff1) == NNTP_POST_RES2) {
	      status = NNTP_OK;
	    }
	  }
	}
      }
    }
#endif	/* NNTP */
  }
  fclose(fp1);
  return(status);
}

/*
 * NNTP ³ǧ
 */

NNTP_ERR_CODE	nntp_noop()
{
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    return(nntp_send(""));
#endif	/* NNTP */
    break;
  default:
    break;
  }
  return(NNTP_OK);
}

#ifndef	SMALL
/*
 * NNTP ϼ
 */

NNTP_ERR_CODE	nntp_description(group_name, description)
     char	*group_name;
     char	*description;
{
  char		buff[BUFF_SIZE];
  unsigned char	*ptr;			/* Τ unsigned	*/
  int		first_line;
  NNTP_ERR_CODE	status;
#ifdef	NSPL
  FILE		*fp;
#endif	/* NSPL */

  first_line = 1;
  *description = '\0';
  status = NNTP_ERR_COMM;
  switch (nntp_connect_mode) {
  case 0:						/* NSPL ³	*/
#ifdef	NSPL
    sprintf(buff, "%s%c%s", news_lib, SLASH_CHAR, NEWS_DESCRIPTION_FILE);
    if ((fp = fopen(buff, "r")) == (FILE*)NULL) {
      print_fatal("Can't open news description list.");
      break;
    }
    while (fgets(buff, sizeof(buff), fp)) {
      if (!strncmp(buff, group_name, strlen(group_name))) {
	ptr = (unsigned char*)&buff[strlen(group_name)];
	if ((*ptr == ' ') || (*ptr == '\t')) {
	  while ((*ptr == ' ') || (*ptr == '\t')) {
	    ptr++;
	  }
	  while (*ptr) {
	    if ((*ptr >= ' ') || (*ptr == '\t') || (*ptr == '\033')) {
	      *description++ = *ptr++;
	    } else {
	      break;
	    }
	  }
	  *description = '\0';
	  status = NNTP_OK;
	  break;
	}
      }
    }
    fclose(fp);
#else	/* !NSPL */
    status = NNTP_ERR_RSV;
#endif	/* !NSPL */
    break;
  case 1:						/* NNTP ³	*/
#ifdef	NNTP
    if (nntp_send(NNTP_DESCRIPTION_CMD)) {
      break;
    }
    while (1) {
      if (nntp_receive(buff, sizeof(buff))) {
	break;
      }
      ptr = (unsigned char*)buff;
      if (first_line) {		/* ơ	*/
	if (atoi(ptr) != NNTP_LIST_RES) {
	  print_fatal("Unexpected NNTP reply in list command.");
	  break;
	}
	first_line = 0;
      } else {			/* 롼׾	*/
	if ((buff[0] == NNTP_END_MARK) && (!buff[1])) {
	  break;
	}
	if (!strncmp(buff, group_name, strlen(group_name))) {
	  ptr = (unsigned char*)&buff[strlen(group_name)];
	  if (((*ptr == ' ') || (*ptr == '\t')) && (status != NNTP_OK)) {
	    while ((*ptr == ' ') || (*ptr == '\t')) {
	      ptr++;
	    }
	    while (*ptr) {
	      if ((*ptr >= ' ') || (*ptr == '\t') || (*ptr == '\033')) {
		*description++ = *ptr++;
	      } else {
		break;
	      }
	    }
	    *description = '\0';
	    status = NNTP_OK;
	  }
	}
      }
    }
#endif	/* NNTP */
    break;
  default:
    break;
  }
  return(status);
}
#endif	/* !SMALL */

/*
 * եɥԡ
 */

char	*copy_field(ptr1, ptr2, field)
     char	*ptr1;
     char	*ptr2;
     char	*field;
{
  register int	i;

  if ((!ptr1) || (!ptr2)) {
    return((char*)NULL);
  }
  i = strlen((char*)field);
  while (i-- > 0) {
    if ((*ptr1++ & 0xdf) != (*field++ & 0xdf)) {
      return((char*)NULL);
    }
  }
  while ((*ptr1 == ' ') || (*ptr1 == '\t')) {
    ptr1++;
  }
  strcpy((char*)ptr2, (char*)ptr1);
  while (*ptr2) {
    if (*ptr2 == '\n') {
      *ptr2 = '\0';
      break;
    }
    ptr2++;
  }
  return(ptr2);
}

/*
 * եɥԡ(NNTP ³/ե)
 */

int	copy_fields(fp, hdr_ptr1, number, mask)
     FILE		*fp;
     struct cpy_hdr	*hdr_ptr1;
     int		number;
     int		mask;	/*
				 * CF_CLR_MASK:Хåե
				 * CF_CNT_MASK:Կ
				 * CF_GET_MASK:եɼ
				 * CF_ADD_MASK:եɲ
				 */
{
  struct cpy_hdr	*hdr_ptr2;
  char			buff[BUFF_SIZE];
  char			*ptr1, *ptr2;
  register int		lines = 0;
  register int		i;

  hdr_ptr2 = hdr_ptr1;
  if (mask & CF_CLR_MASK) {
    for (i = 0; i < number; i++) {
      if (ptr1 = hdr_ptr2->field_buff) {
	*ptr1 = '\0';
      }
      hdr_ptr2++;
    }
  }
  if (!(mask & (CF_CNT_MASK | CF_GET_MASK))) {
    return(0);
  }
  ptr1 = (char*)NULL;
  while (1) {
    if (fp != (FILE*)NULL) {
      if (!fgets(buff, sizeof(buff), fp)) {
	break;
      }
    } else {
      if (nntp_receive(buff, sizeof(buff))) {
	break;
      }
      if ((buff[0] == NNTP_END_MARK) && (!buff[1])) {
	break;
      }
    }
    lines++;
    if ((buff[0] == ' ') || (buff[0] == '\t')) {
      if (ptr1) {
	ptr2 = buff;
	if (mask & CF_SPC_MASK) {
	  while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	    ptr2++;
	  }
	}
	if ((int)(strlen(ptr1) + strlen(ptr2)) < (hdr_ptr2->buff_size)) {
	  strcat(ptr1, ptr2);
	  ptr2 = ptr1;
	  while (*ptr2) {
	    if ((*ptr2 == '\n') && (!*(ptr2 + 1))) {
	      *ptr2 = '\0';
	      break;
	    }
	    ptr2++;
	  }
	}
      }
    } else {
      ptr1 = (char*)NULL;
      hdr_ptr2 = hdr_ptr1;
      for (i = 0; i < number; i++) {
	if (!strncasecmp(buff, hdr_ptr2->field_name,
			 strlen(hdr_ptr2->field_name))) {
	  if (ptr1 = hdr_ptr2->field_buff) {
	    ptr2 = &buff[strlen(hdr_ptr2->field_name)];
	    while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	      ptr2++;
	    }
	    if ((mask & CF_ADD_MASK) && *ptr1) {
	      if ((int)(strlen(ptr1) + strlen(ptr2) + 1) <
		  (hdr_ptr2->buff_size)) {
		strcat(ptr1, "\n");
		strcat(ptr1, ptr2);
	      }
	    } else {
	      if ((int)strlen(ptr2) < (hdr_ptr2->buff_size)) {
		strcpy(ptr1, ptr2);
	      }
	    }
	    ptr2 = ptr1;
	    while (*ptr2) {
	      if ((*ptr2 == '\n') && (!*(ptr2 + 1))) {
		*ptr2 = '\0';
		break;
	      }
	      ptr2++;
	    }
	    if (!*ptr1) {		/* եɸ */
	      *ptr1++ = ' ';
	      *ptr1 = '\0';
	    }
	  }
	  break;
	}
	hdr_ptr2++;
      }
      if ((!buff[0]) || (buff[0] == '\n')) {
	if (mask & CF_CNT_MASK) {
	  if (fp != (FILE*)NULL) {
	    while (fgets(buff, sizeof(buff), fp)) {
	      lines++;
	    }
	  } else {
	    while (1) {
	      if (nntp_receive(buff, sizeof(buff))) {
		break;
	      }
	      if ((buff[0] == NNTP_END_MARK) && (!buff[1])) {
		break;
	      }
	      lines++;
	    }
	  }
	}
	if (!(mask & CF_HED_MASK)) {
	  break;
	}
      }
    }
  }
  return(lines);
}

/*
 * ʸͤѴ
 */

static int	atoi2(ptr)
     char	**ptr;
{
  int	n;
  char	*ptr2;
  
  ptr2 = *ptr;
  
  while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
    ptr2++;
  }
  if (!isdigit(*ptr2)) {
    return(-1);
  }
  n = atoi(ptr2);
  while (isdigit(*ptr2)) {
    ptr2++;
  }
  while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
    ptr2++;
  }
  *ptr = ptr2;
  return(n);
}

#ifdef	NSPL
/*
 * 
 *
 * ::顼,:ֹ
 */

static int	nspl_search_article(message_id)
     char	*message_id;
{
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  char		*ptr1, *ptr2;
  FILE		*fp;
#ifdef	HAVE_FILES
  FILES_STRUCT	dp;
#else	/* !HAVE_FILES */
  DIR_PTR	*dp;
  DIR		*dir_ptr;
#endif	/* !HAVE_FILES */
  long		article_number;
  register int	match;
  register int	number;

  if (!current_group[0]) {
    print_fatal("News group not selected.");
    return(-1);
  }
  match = 0;
  article_number = -1;
  sprintf(buff2, "%s %s", MESSAGE_FIELD, message_id);
#ifdef	HAVE_FILES
  sprintf(buff1, "%s%c*.*", current_group, SLASH_CHAR);
  if (!dos_files(buff1, &dp, FILE_ATTR)) {
    do {
#ifdef	__TURBOC__
      number = atoi(dp.ff_name);
      sprintf(buff1, "%d", number);
      if (strcmp(buff1, dp.ff_name)) {
	continue;
      }
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR, dp.ff_name);
#else	/* !__TURBOC__ */
      number = atoi(dp.name);
      sprintf(buff1, "%d", number);
      if (strcmp(buff1, dp.name)) {
	continue;
      }
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR, dp.name);
#endif	/* !__TURBOC__ */
      if ((fp = fopen(buff1, "r")) == (FILE*)NULL) {
	continue;
      }
      while (fgets(buff1, sizeof(buff1), fp)) {
	if ((!buff1[0]) || (buff1[0] == '\n')) {
	  break;
	}
	ptr1 = buff1;
	ptr2 = buff2;
	match = 1;
	while (*ptr2) {
	  if ((*ptr1++ & 0xdf) != (*ptr2++ & 0xdf)) {
	    match = 0;
	    break;
	  }
	}
	if (match) {
	  break;
	}
      }
      fclose(fp);
      if (match) {
	article_number = number;
	break;
      }
    } while (!dos_nfiles(&dp));
#else	/* !HAVE_FILES */
  if ((dir_ptr = opendir(current_group)) != (DIR*)NULL) {
    while ((dp = readdir(dir_ptr)) != (DIR_PTR*)NULL) {
      number = atoi(dp->d_name);
      sprintf(buff1, "%d", number);
      if (strcmp(buff1, dp->d_name)) {
	continue;
      }
      sprintf(buff1, "%s%c%s", current_group, SLASH_CHAR, dp->d_name);
      if ((fp = fopen(buff1, "r")) == (FILE*)NULL) {
	continue;
      }
      while (fgets(buff1, sizeof(buff1), fp)) {
	if ((!buff1[0]) || (buff1[0] == '\n')) {
	  break;
	}
	ptr1 = buff1;
	ptr2 = buff2;
	match = 1;
	while (*ptr2) {
	  if ((*ptr1++ & 0xdf) != (*ptr2++ & 0xdf)) {
	    match = 0;
	    break;
	  }
	}
	if (match) {
	  break;
	}
      }
      fclose(fp);
      if (match) {
	article_number = number;
	break;
      }
    }
    closedir(dir_ptr);
#endif	/* !HAVE_FILES */
  }
  return(article_number);
}
#endif	/* NSPL */

/*
 * ǧ
 */

void	confirm_article(name, min_ptr, max_ptr)
    char	*name;
    int		*min_ptr;
    int		*max_ptr;
{
#ifdef	NSPL
  char			buff1[SMALL_BUFF];
  char			buff2[SMALL_BUFF];
  char			*ptr;
#ifdef	HAVE_FILES
  FILES_STRUCT		dp;
#else	/* !HAVE_FILES */
  DIR_PTR		*dp;
  DIR			*dir_ptr;
#endif	/* !HAVE_FILES */
  register int		number;
  register int		min_number;
  register int		max_number;

  if (nntp_connect_mode) {				/* NNTP ³	*/
    return;
  }
  strcpy(buff2, name);
  ptr = buff2;
  while (*ptr) {
    if (*ptr == NEWS_GROUP_SEPARATER) {
      *ptr = SLASH_CHAR;
    }
    ptr++;
  }
  sprintf(buff1, "%s%c%s", news_spool, SLASH_CHAR, buff2);
  min_number = max_number = 0;
#ifdef	HAVE_FILES
  sprintf(ptr, "%c*.*", SLASH_CHAR);
  if (!dos_files(buff1, &dp, FILE_ATTR)) {
    do {
#ifdef	__TURBOC__
      number = atoi(dp.ff_name);
      sprintf(buff2, "%d", number);
      if (!strcmp(buff2, dp.ff_name)) {
#else	/* !__TURBOC__ */
      number = atoi(dp.name);
      sprintf(buff2, "%d", number);
      if (!strcmp(buff2, dp.name)) {
#endif	/* !__TURBOC__ */
	if ((min_number > number) || (!min_number)) {
	  min_number = number;
	}
	if (max_number < number) {
	  max_number = number;
	}
      }
    } while (!dos_nfiles(&dp));
#else	/* !HAVE_FILES */
  if ((dir_ptr = opendir(buff1)) != (DIR*)NULL) {
    while ((dp = readdir(dir_ptr)) != (DIR_PTR*)NULL) {
      number = atoi(dp->d_name);
      sprintf(buff2, "%d", number);
      if (!strcmp(buff2, dp->d_name)) {
	if ((min_number > number) || (!min_number)) {
	  min_number = number;
	}
	if (max_number < number) {
	  max_number = number;
	}
      }
    }
    closedir(dir_ptr);
#endif	/* !HAVE_FILES */
    if ((*min_ptr < min_number) && min_number) {
      print_warning("Min-number fixed in %s.", name);
      *min_ptr = min_number;
    }
#ifdef	notdef
    if ((*max_ptr > max_number) && max_number) {
      print_warning("Max-number fixed in %s.", name);
      *max_ptr = max_number;
    }
#endif	/* notdef */
  }
#endif	/* NSPL */
}

#ifdef	NSPL
/*
 * ѥץ顼ϥɥ
 * (Broken Pipe)
 */

static void	post_pipe_error()
{
  print_fatal("inews broken pipe.");
}
#endif	/* NSPL */

#ifdef	NNTP
#ifdef	X68K
int	gethostname(name, namelen)
     char	*name;
     int	namelen;
{
  char	*ptr;

  *name = '\0';
  ptr = getenv("HOSTNAME");
  if (ptr == (char*)NULL) {
    ptr = getenv("HOST");
  }
  if ((ptr == (char*)NULL) || strlen(ptr) >= namelen) {
    return(-1);
  }
  strcpy(name, ptr);
  return(0);
}
#endif	/* X68K */

/*
 * INN å
 *
 * :(0:INNʳ,0ʳ:INN)
 */

static int	inn_check(str1)
     char	*str1;
{
  int	length;

  length = strlen(INN_STRING);
  while (*str1) {
    if (!strncmp(str1, INN_STRING, length)) {
      return(1);
    }
    str1++;
  }
  return(0);
}

#ifdef XOVER
/*
 * إå(XOVER)
 */

NNTP_ERR_CODE	nntp_xover(min, max)
     int	min;
     int	max;
{
  char	buff[BUFF_SIZE];
  int	first;
  int	status;

  first = 1;
  if (max) {
    sprintf(buff, "%s %d-%d", NNTP_XOVER_CMD, min, max);
  } else {
    sprintf(buff, "%s %d", NNTP_XOVER_CMD, min);
  }

  if (nntp_send(buff)) {
    return(NNTP_ERR_COMM);
  }
  status = NNTP_OK;
  while (1) {
    if (nntp_receive(buff, sizeof(buff))) {
      status = NNTP_ERR_COMM;
      break;
    }
    if (first) {		/* ơ	*/
      if (atoi(buff) != NNTP_XOVER_RES) {
	print_fatal("Unexpected NNTP reply in xover command.");
	status = NNTP_ERR_PROT;
	break;
      }
      first = 0;
    } else {			/* إå	*/
      if ((buff[0] == NNTP_END_MARK) && (!buff[1])) {
	break;
      }
      if (xover_copy_field(buff)) {
	print_fatal("Unexpected xover header format.");
	status = NNTP_ERR_PROT;
      }
    }
  }
  return(status);
}
#endif	/* XOVER */
#endif	/* NNTP */
